package com.gxwebsoft.cms.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.cms.service.MpAdService;
import com.gxwebsoft.cms.entity.MpAd;
import com.gxwebsoft.cms.param.MpAdParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 小程序广告位控制器
 *
 * @author 科技小王子
 * @since 2024-07-23 01:53:01
 */
@Api(tags = "小程序广告")
@RestController
@RequestMapping("/api/cms/mp-ad")
public class MpAdController extends BaseController {
    @Resource
    private MpAdService mpAdService;

    @ApiOperation("分页查询小程序广告位")
    @GetMapping("/page")
    public ApiResult<PageResult<MpAd>> page(MpAdParam param) {
        // 使用关联查询
        return success(mpAdService.pageRel(param));
    }

    @ApiOperation("查询全部小程序广告位")
    @GetMapping()
    public ApiResult<List<MpAd>> list(MpAdParam param) {
        // 使用关联查询
        return success(mpAdService.listRel(param));
    }

    @PreAuthorize("hasAuthority('cms:mpAd:list')")
    @ApiOperation("根据id查询小程序广告位")
    @GetMapping("/{id}")
    public ApiResult<MpAd> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(mpAdService.getByIdRel(id));
    }

    @ApiOperation("添加小程序广告位")
    @PostMapping()
    public ApiResult<?> save(@RequestBody MpAd mpAd) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         mpAd.setUserId(loginUser.getUserId());
        }
        if (mpAdService.save(mpAd)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改小程序广告位")
    @PutMapping()
    public ApiResult<?> update(@RequestBody MpAd mpAd) {
        if (mpAdService.updateById(mpAd)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除小程序广告位")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (mpAdService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加小程序广告位")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<MpAd> list) {
        if (mpAdService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改小程序广告位")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<MpAd> batchParam) {
        if (batchParam.update(mpAdService, "ad_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除小程序广告位")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (mpAdService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
